import sys, os, string
import urllib
import _winreg

def mk_winreg_ext(ext, tmpl_map):
    cmd = '"%s" --wh "%%1"' % (os.path.normpath(os.path.join(tmpl_map['btransformer_base'], 'btransformer.cmd')), )
    cr = _winreg.ConnectRegistry(None, _winreg.HKEY_CLASSES_ROOT)
    tk = _winreg.CreateKey(cr, ext)
    ext_w = _winreg.QueryValue(tk, '')
    print ext_w
    if ext_w != '':
        tk = _winreg.CreateKey(cr, ext_w)
    tk = reduce(lambda key, sub_key: _winreg.CreateKey(key, sub_key), ('shell', 'TransformToPdfPrs'), tk)
    _winreg.SetValue(tk, '', _winreg.REG_SZ, 'Transform to PDF for PRS-50x')
    tk = _winreg.CreateKey(tk, 'command')
    _winreg.SetValue(tk, '', _winreg.REG_SZ, cmd)

if __name__ == '__main__':    
    inst_dir = os.path.dirname(sys.executable)
    btransformer_base = inst_dir.replace('\\', '/')
    btransformer_base_quoted = urllib.quote(btransformer_base, safe = '/:')
    btransformer_base_quoted_cmd = btransformer_base_quoted.replace('%', '%%')
    tmpl_map = {'btransformer_base': btransformer_base,
                'btransformer_base_quoted': btransformer_base_quoted,
                'btransformer_base_quoted_cmd': btransformer_base_quoted_cmd,}    
    mk_winreg_ext('.zip', tmpl_map)
    mk_winreg_ext('.fb2', tmpl_map)
    import atexit, msvcrt
    def getch():
        print 'Press any key...'
        msvcrt.getch()
    atexit.register(getch)
